/*
  RCTractor.h - Library for controlling RC Tractors.
  Created by Oisin O'Conchubhair, September 20, 2015.
  Released into the public domain.
*/
#ifndef RCTractorControllerV1_h
#define RCTractorControllerV1_h

#include "Arduino.h"

class RCTractorControllerV1
{
  public:
    RCTractorControllerV1();
    void Update();
    void Check_Light_Buttons();
    void Check_Func_Buttons();
    void Check_Fast_Select();
    void Check_Joys();
    void Check_Encoders();
    void Menu_Update();
    void Setup();
	long readVcc();
	void Controller_Voltage();
	void Vehicle_Voltage(long _Vehcile_V);

	    void Start_Vehicle();
	    	    void Start_Hitachi();
	    void Control32_Pulse(int Num_Pulse);
	      	void Update_Dash(int clear);


  private:
  	void Send_NRF();
  	void Send_IR32();
  	void Send_XBee();

unsigned char bitswap (unsigned char x);

    int _Motor_PWM;
    int _Motor_con1;
    int _Motor_con2;
    int _Motor_Move;
    int _Left_Ind;
    int _Right_Ind;
    int _Left_Ind_On;
    int _Right_Ind_On;
    int _Timer1_Counter;
    int _Light_Val;
    int _Head_Lights;
    int _Brake_Lights;
    int _Spot_Lights;
    int _Vehicle_No;
    int _V_ID;

  int _JX_L;
  int _JY_L;
  int _JX_R;
  int _JY_R;
  int _POT1;
  int _POT2;
  int _POT3;
  int _POT4;
  int _S_Left_Joy;
  int _S_Right_Joy;
  int _VQS_V1;
  int _VQS_V2;
  int _VQS_V3;
  int _VQS_V4;
  int _VQS_V5;
  int _VQS_V6;
  int _VQS_V7;
  int _VQS_V8;
  int _VQS_V9;
  int _VQS_V10;
  int _S_DB;
  int _S_FB;
  int _S_WL;
  int _S_4;
  int _S_8;
  int _S_F1;
  int _S_F2;
  int _S_F3;
  int _S_Up;
  int _S_EN1;
  int _S_EN2;
  int _S_Down;
  int _S_Select;
  int _S_Back;
  int _DIP1;
  int _DIP2;
  int _DIP3;
  int _DIP4;
  int _DIP5;
  int _Left_Joy_X;
  int _Left_Joy_Y;
  int _Right_Joy_X;
  int _Right_Joy_Y;
  int _P1;
  int _P2;
  int _P3;
  int _P4;
  int _Left_Joy_X_Old;
  int _Left_Joy_Y_Old;
  int _Right_Joy_X_Old;
  int _Right_Joy_Y_Old;
    int _POT1_Val;
    int _POT2_Val;
    int _POT3_Val;
  int _POT4_Val;
    int _POT1_Val_Old;
    int _POT2_Val_Old;
    int _POT3_Val_Old;
  int _POT4_Val_Old;
  int _P1_Old;
  int _P2_Old;
  int _P3_Old;
  int _P4_Old;
  int _Left_Joy_Button;
  int _Right_Joy_Button;
  int _LED_Data;
  int _FUNC_Data;
  int _IR_LED;



};


#endif